<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
 * Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
 * Use is subject to license terms.
-->
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>Attaching Source Code to a JAR File</title>
	<link rel="StyleSheet" href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
</head>
<body>
<h2>Attaching Source Code to a JAR File</h2>
<p><small><a href="#seealso">See Also</a></small></p>
<p> When you add a JAR file or folder of compiled classes to a project's classpath,
	 it is often useful to add the source files for those classes so that you
	can view their contents when working with them. Attaching source code to a
	JAR file or compiled classes folder lets the IDE know where to find the source
	code for those classes. You can then step into the source files when debugging
	and open the source files with the Go To Source command. </p>
  <ul class="note"> 
    <li>In order for code completion to  work properly in the IDE, you must either
    	attach a complete set of source files as a folder or add the available
    	source files as a Zip archive. </li>
  </ul>
<p><b>To attach source code to a JAR file or compiled classes folder:</b></p>
<ol>
  <li>Choose Tools  &gt; Libraries from the main menu.</li>
  <li>In the left pane of the Ant Library Manager, select the project library within
  which the JAR file you want to add the source code to is located.
  <ul class="note">
        <li>Only libraries already registered with the IDE are listed in the Ant Library Manager's
        Class Libraries list.</li>
  </ul>
  </li>
    <li>If the JAR file or classes folder for which you want to add the source
    code has not already been added to a registered library, create a new empty
    library using the New Library button. Next, in the Classpath tab click Add JAR/Folder and specify the 
    location of the JAR file containing the compiled class files.   
    <ul class="note">
        <li>A class library can contain multiple JAR files as well as their Javadoc documentation and
        source code.</li>
   </ul>
    </li>
   <li>In the Sources tab, click Add JAR/Folder to add the folder or archive file
    containing the source code. </li>
   <li>Click OK to exit the Ant Library Manager. 
    <p>The IDE adds the selected JAR files and source code to the specified library
    and automatically registers the source code in every project
    that has that JAR file on its classpath.</p></li>
</ol>

  <ul class="note"> 
    <li>When you create a Java class library for a
    	single JAR  file, you can simply add the JAR file to the project's classpath
    	to make the associated Javadoc and source code available. If your
    	Java library contains multiple JAR files, however, you must add the library
    	itself to the classpath. Adding the library to the classpath also makes
    	it easier to share the project with other developers. </li>
<li>You can also associate the sources with a JAR file using the project's Project 
Properties window. However, doing so creates the association only for that project. 
Open the Project Properties dialog box by right-clicking the project node and 
choosing Properties. Select the Libraries node in the Categories pane. Then 
select the JAR with which you want to associate the sources and click Edit. You can 
then specify the sources to be associated.</li>
  </ul>

<p><b>To attach source code for a Java platform:</b></p>
<ol>
  <li>Choose Tools  &gt; Java Platforms from the main menu.</li>
  <li>Select the platform in the left pane of the dialog box.</li>
  <li>In the Sources tab, add the folders or archive files containing the source code.</li>
</ol>

  <ul class="note"> 
    <li>For <object classid="java:com.sun.java.help.impl.JHSecondaryViewer">
        <param name="content" value="../project/csh/glossary_freeform.html">
        <param name="viewerActivator" value="javax.help.LinkLabel">
        <param name="viewerStyle" value="javax.help.Popup">
        <param name="viewerSize" value="400,160">
        <param name="text" value="free-form projects">
        <param name="textFontSize" value="medium">
        <param name="textFontFamily" value="SansSerif">
        <param name="textFontStyle" value="italic">
        <param name="textFontWeight" value="bold">
        <param name="textColor" value="blue">
      </object>
    	, you set the target JDK in your Ant script and specify the source 
      level in the  Project Properties dialog box. When you step into 
      JDK classes, the IDE searches the platforms registered in the Java Platform
    	Manager for a Java platform with a matching source level. If no matching
    	Java platform is found, the IDE opens the source code for the IDE's default
    	platform.</li>
  </ul>

<dl>
    <dt><a name="seealso">See Also</a></dt>
    <dd><a href="../project/proj_jdk.html">Setting the Target JDK</a></dd>
    <dd><a href="../compile/comp_classpath.html">Managing the Classpath</a></dd>
    <dd><a href="debug_local.html">Starting a Local Debugging Session</a></dd>
    <dd><a href="debug_remote.html">Starting a Remote Debugging Session</a> </dd>
</dl>

<hr>
<small><a href="../credits.html">Legal Notices</a></small> 
<table cellpadding="50" border="0">
  <tr> 
    <td>&nbsp;</td>
  </tr>
</table>
</body>
</html>
